"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
exports.__esModule = true;
var keytar_1 = require("keytar");
var cookie_1 = require("cookie");
var inquirer = require("inquirer");
var SERVICE = 'HttpProxySecureCookies';
/**
 * Serialize cookies object to the cookie string as seen in request headers.
 */
function toCookieString(cookies) {
    return Object.entries(cookies)
        .map(function (_a) {
        var key = _a[0], value = _a[1];
        return cookie_1.serialize(key, value);
    })
        .join('; ');
}
/**
 * Parse the `Set-Cookie` header from remote servers.
 */
function parseSetCookie(cookieHeaders) {
    if (!cookieHeaders)
        return [[], {}];
    var cookieArray = Array.isArray(cookieHeaders)
        ? cookieHeaders
        : [String(cookieHeaders)];
    var cookies = {};
    return [
        cookieArray,
        cookieArray
            .map(function (x) { return x.split(';', 1)[0].split('=', 2); })
            .reduce(function (acc, _a) {
            var key = _a[0], value = _a[1];
            acc[key] = value;
            return acc;
        }, cookies),
    ];
}
/**
 * Generate a proxy config that points to a remote host.
 */
function secureCookieProxy(options) {
    var _a = typeof options === 'string' ? { target: options } : options, target = _a.target, keychainAccount = _a.keychainAccount, _b = _a.unauthorizedStatusCode, unauthorizedStatusCode = _b === void 0 ? [401] : _b, cookieRewrite = _a.cookieRewrite, restOptions = __rest(_a, ["target", "keychainAccount", "unauthorizedStatusCode", "cookieRewrite"]);
    // default account is the target sans protocol
    var account = keychainAccount || target.split('://')[1];
    var unauthroizedCode = new Set(Array.isArray(unauthorizedStatusCode)
        ? unauthorizedStatusCode
        : [unauthorizedStatusCode]);
    var secureCookies;
    var waitingForInput = false;
    function getFromKeyChain() {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, keytar_1.getPassword(SERVICE, account)];
            });
        });
    }
    function askForUserInput(message) {
        return __awaiter(this, void 0, void 0, function () {
            var cookieString;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        waitingForInput = true;
                        return [4 /*yield*/, inquirer.prompt([
                                {
                                    type: 'password',
                                    name: 'cookieString',
                                    message: message
                                },
                            ])];
                    case 1:
                        cookieString = (_a.sent()).cookieString;
                        return [4 /*yield*/, keytar_1.setPassword(SERVICE, account, cookieString)];
                    case 2:
                        _a.sent();
                        waitingForInput = false;
                        console.log('\nSuccessfully saved your cookie. Please refresh.');
                        return [2 /*return*/, cookieString];
                }
            });
        });
    }
    /**
     * Read cookies from keychain or user input.
     */
    function getCookies(message) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        if (waitingForInput)
                            return [2 /*return*/, null];
                        _d.label = 1;
                    case 1:
                        _d.trys.push([1, 6, , 8]);
                        _a = cookie_1.parse;
                        if (!message) return [3 /*break*/, 3];
                        return [4 /*yield*/, askForUserInput(message)];
                    case 2:
                        _b = _d.sent();
                        return [3 /*break*/, 5];
                    case 3: return [4 /*yield*/, getFromKeyChain()];
                    case 4:
                        _b = _d.sent();
                        _d.label = 5;
                    case 5:
                        secureCookies = _a.apply(void 0, [(_b) ||
                                '']);
                        return [3 /*break*/, 8];
                    case 6:
                        _c = _d.sent();
                        return [4 /*yield*/, getCookies('Invalid cookie string, please try again: ')];
                    case 7:
                        _d.sent();
                        return [3 /*break*/, 8];
                    case 8: return [2 /*return*/, secureCookies];
                }
            });
        });
    }
    /**
     * Add secure cookies to proxy request header
     */
    function addCookie(proxyReq, req) {
        proxyReq.setHeader('cookie', toCookieString(__assign(__assign({}, secureCookies), cookie_1.parse(req.headers.cookie || ''))));
    }
    // quitely get initial cookies
    getCookies();
    return __assign(__assign({ secure: false, changeOrigin: true, target: target, ws: target.startsWith('ws') }, restOptions), { onProxyReq: addCookie, onProxyReqWs: addCookie, onProxyRes: function (proxyRes, req, res) {
            // update cookies if API returns 401
            if (proxyRes.statusCode && unauthroizedCode.has(proxyRes.statusCode)) {
                getCookies("\nAuthentication failed for " + target + req.url + "\n\nYou either haven't provide an auth cookie or it expired.\nPlease login to " + target + " and copy the HTTP cookie string here.\n\nIt will be securely stored in system keychain:");
            }
            // add missing cookies to the response so they can be used on the client
            // side as well.
            if (secureCookies) {
                var reqCookies_1 = cookie_1.parse(req.headers.cookie || '');
                var _a = parseSetCookie(res.getHeader('set-cookie')), cookieHeaders_1 = _a[0], resCookies_1 = _a[1];
                var clientCookies_1 = cookieRewrite
                    ? cookieRewrite(secureCookies)
                    : secureCookies;
                var hasMissingCookie_1 = false;
                Object.keys(clientCookies_1).forEach(function (key) {
                    if (!(key in reqCookies_1) && !(key in resCookies_1)) {
                        // set all secure cookie to the root path
                        cookieHeaders_1.push(cookie_1.serialize(key, clientCookies_1[key], { path: '/' }));
                        hasMissingCookie_1 = true;
                    }
                });
                if (hasMissingCookie_1) {
                    res.setHeader('Set-Cookie', cookieHeaders_1);
                }
            }
        } });
}
exports["default"] = secureCookieProxy;
