import { Config as ProxyOptions } from 'http-proxy-middleware';
declare type Cookies = {
    [key: string]: string;
};
export interface SecureCookieProxyOptions extends ProxyOptions {
    target: string;
    unauthorizedStatusCode?: number | number[];
    keychainAccount?: string;
    /**
     * Additional processing on secure cookies before setting them to the client
     */
    cookieRewrite?: (cookies: Cookies) => Cookies;
}
/**
 * Generate a proxy config that points to a remote host.
 */
export default function secureCookieProxy(options: string | SecureCookieProxyOptions): ProxyOptions;
export {};
